io.vertx.core.http

## Interface HttpServerFileUpload

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase

      public interface HttpServerFileUpload
      extends ReadStream<Buffer>

  Represents an file upload from an HTML FORM.
  Author:
    Norman Maurer

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `cancelStreamToFileSystem()` Try to cancel the file system streaming, the streamed file will be deleted.
    `String` | `charset()`
    `String` | `contentTransferEncoding()`
    `String` | `contentType()`
    `HttpServerFileUpload` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `HttpServerFileUpload` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `HttpServerFileUpload` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `AsyncFile` | `file()`
    `String` | `filename()`
    `HttpServerFileUpload` | `handler(Handler<Buffer> handler)` Set a data handler.
    `boolean` | `isSizeAvailable()`
    `String` | `name()`
    `HttpServerFileUpload` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `HttpServerFileUpload` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `long` | `size()` The size of the upload may not be available until it is all read.
    `Future<Void>` | `streamToFileSystem(String filename)` Stream the content of this upload to the given file on storage.
    `void` | `streamToFileSystem(String filename, Handler<AsyncResult<Void>> handler)` Stream the content of this upload to the given file on storage.

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `pipe, pipeTo, pipeTo`

- - ### Method Detail

    - #### exceptionHandler

          HttpServerFileUpload exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          HttpServerFileUpload handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          HttpServerFileUpload endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          HttpServerFileUpload pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          HttpServerFileUpload resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          HttpServerFileUpload fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### streamToFileSystem

          void streamToFileSystem(String filename,
                                  Handler<AsyncResult<Void>> handler)

      Stream the content of this upload to the given file on storage.
      Parameters:
        `filename` - the name of the file

    - #### streamToFileSystem

          Future<Void> streamToFileSystem(String filename)

      Stream the content of this upload to the given file on storage.

      If the stream has a failure or is cancelled the created file will be deleted.

      Parameters:
        `filename` - the name of the file

    - #### cancelStreamToFileSystem

          boolean cancelStreamToFileSystem()
                                    throws IllegalStateException

      Try to cancel the file system streaming, the streamed file will be deleted.
      Returns:
        `true` when the stream is cancelled, otherwise it means that stream is finished
      Throws:
        `IllegalStateException` - when no stream is in progress

    - #### filename

          String filename()

      Returns:
        the filename which was used when upload the file.

    - #### name

          String name()

      Returns:
        the name of the attribute

    - #### contentType

          String contentType()

      Returns:
        the content type for the upload

    - #### contentTransferEncoding

          String contentTransferEncoding()

      Returns:
        the contentTransferEncoding for the upload

    - #### charset

          String charset()

      Returns:
        the charset for the upload

    - #### size

          long size()

      The size of the upload may not be available until it is all read. Check `isSizeAvailable()` to determine this
      Returns:
        the size of the upload (in bytes)

    - #### isSizeAvailable

          boolean isSizeAvailable()

      Returns:
        `true` if the size of the upload can be retrieved via `size()`.

    - #### file

          AsyncFile file()

      Returns:
        the async uploaded file when `streamToFileSystem(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` has been used and the file is available

Copyright © 2021 Eclipse. All rights reserved.